#[macro_use]
extern crate log;
extern crate rag;
extern crate serde;
#[macro_use]
extern crate serde_derive;
extern crate toml;

mod app;
mod apps;
mod proc;
mod result;

use apps::Apps;
use result::Result;

fn main() {
	if let Err(e) = rag::init() {
		println!("FATAL: Error initializing logger: {:?}", e);
		std::process::exit(1);
	}

	if let Err(e) = startup() {
		error!("FATAL: {:?}", e);
		std::process::exit(1);
	}
}

fn startup() -> Result<()> {
	let apps = Apps::load("sup.toml")?;
	let (procs, holds) = apps.start();
	apps.run(procs, holds)?;
	Ok(())
}
